% test lpevalselfcc interface and values against dense evals. Requires MPSpack.
% Barnett 3/19/11, new QP interface & case (choose qp.nei>0) added 3/24/11
clear, verb=0;

if 0 % basic test of four kernel values
  k = 10; nord = 16;
  y = 0; ny = 1; x = 1+2i; nx = -1i; % fixed y=source, x=target (not swapped!)
  testkernel(k)
  fprintf('should equal these values...\n')
  layerpot.Skernel(k,x,nx,y,ny)
  layerpot.Dkernel(k,x,nx,y,ny)
  layerpot.DTkernel(k,x,nx,y,ny)
  layerpot.Tkernel(k,x,nx,y,ny)
end

% true closed curve (non-quasi-periodic) case, all four operator blocks:
N=5e2; k=10; qp.nei=0; s = segment.smoothstar(N,0.3,3); alpord=16; iprec=4;
sig = exp(5*2i*pi*(1:N).'/N); tau = exp(7*2i*pi*(1:N).'/N); % densities at nodes
ifsig = 1; iftau = 1; ifpot = 1; ifnd = 1; % switch for testing S, D, etc blocks
qp.winding = 0; qp.dvec = [3.0;0.0]; qp.alpha = exp(2i*pi/7.0); % QP params
e = qp.dvec(1) + 1i*qp.dvec(2);  % QP translation as C-#
if verb, figure; for j=-qp.nei:qp.nei  % show a pic of all source segments
    s.translate(j*e).plot; hold on; end, drawnow; end
tic; V = lpevalselfcc([real(s.x) imag(s.x)]',[real(s.nx) imag(s.nx)]', ...
            s.speed'/(2*pi), ifsig,sig,iftau,tau, k,[],alpord,iprec, ...
                      qp, ifpot,ifnd); t=toc; % speed/2pi = N*weights
sig = sig*ifsig; tau = tau*iftau;  % switch off for remainder...
if ifpot, v = V.pot - tau/2; end; if ifnd, vn = V.nd + sig/2; end   % int JRs
fprintf('\tLP eval (FMM+Alpert) done %.3g secs = %.3g pts (src) per sec\n',...
        t, N/t)
fprintf('\t  counting QP copies, %.3g pts (src) per sec\n', N*(1+2*qp.nei)/t)
o.quad='a'; o.ord=alpord; % opts for lp bases quadrature in mpspack
d = domain(s,1); d.k = k; d.addlayerpot(s, 's', o); d.addlayerpot(s, 'd', o);
if N<=1e3  % otherwise dense O(N^2) gets slow!
  tic; [A An] = d.evalbases(s);  % dense self-evaluation matrices
  if qp.nei>0
    for j=[-qp.nei:-1 1:qp.nei], [Aj Anj] = d.evalbases(s.translate(-j*e));
      A = A + qp.alpha^j * Aj; An = An + qp.alpha^j * Anj; 
    end
  end
  t=toc; fprintf('\tdense basis eval done in %.3g secs\n', t)
  tic; u = A*[sig;tau]; un = An*[sig;tau]; t=toc;
  fprintf('\tdense mat-vecs done %.3g secs\n', t)
  if ifpot
  fprintf('\tl2-norm of v-u   = %.3g     (should be small)\n', norm(v-u)),end
  if ifnd
  fprintf('\tl2-norm of vn-un = %.3g     (should be small)\n', norm(vn-un))
%  figure; plot([real(u) real(v)]); figure; plot([real(un) real(vn)]);
  fprintf('\tNote: errors in T operator will be large since not T_1-T_2\n'),end
end

% test for S op... check A is correct when o.ord=0, and FMM correct
%B = (1i/4)*besselh(0,k*abs(repmat(s.x,[1 N])-repmat(s.x.',[N 1])));
%B = B.*repmat(s.w, [N 1]); B(diagind(B)) = 0; norm(A(1:N,1:N)-B)
%norm(B*sig - V.pot)
